摘要:先放一行,或一列把堆顶的最小元素取出来,取次,如果该有下一行下一列的,放入堆中最小的个元素已经在上面的循环被完了,下一个堆顶元素就是
Problem
Given a n x n matrix where each of the rows and columns are sorted in ascending order, find the kth smallest element in the matrix.
Note that it is the kth smallest element in the sorted order, not the kth distinct element.
Example:
matrix = [ [ 1, 5, 9], [10, 11, 13], [12, 13, 15] ], k = 8, return 13.
Note:
You may assume k is always valid, 1 ≤ k ≤ n^2.
class Solution { public int kthSmallest(int[][] matrix, int k) { int n = matrix.length; Queuequeue = new PriorityQueue ((a, b)->a.val-b.val); //先放一行,或一列 for (int i = 0; i < n; i++) queue.offer(new Node(i, 0, matrix[i][0])); //把堆顶的最小元素取出来,取k-1次,如果该node有下一行/下一列的node,放入堆中 for (int i = 0; i < k-1; i++) { Node node = queue.poll(); if (node.y == n-1) continue; else queue.offer(new Node(node.x, node.y+1, matrix[node.x][node.y+1])); } //最小的k-1个元素已经在上面的for循环被poll完了,下一个堆顶元素就是kth smallest return queue.poll().val; } } class Node { int x; int y; int val; public Node(int x, int y, int val) { this.x = x; this.y = y; this.val = val; } }
文章版权归作者所有,未经允许请勿转载,若此文章存在违规行为,您可以联系管理员删除。
转载请注明本文地址:https://www.ucloud.cn/yun/72219.html
摘要:复杂度是,其中。这做法和异曲同工。看了网上给的解法,没有二分,二分的是结果。每次找到一个,然后求比它小的元素的个数,根据个数大于还是小于来二分。参考算的时候可以优化 378. Kth Smallest Element in a Sorted Matrix 题目链接:https://leetcode.com/problems... 求矩阵里面第k小的数,首先比较容易想到的是用heap来做...
摘要:因此我们可以采用部分元素堆排序即可。即我们每次只需要可能构成第个元素的值进行堆排序就可以了。 题目要求 Given a n x n matrix where each of the rows and columns are sorted in ascending order, find the kth smallest element in the matrix. Note that...
Given a n x n matrix where each of the rows and columns are sorted in ascending order, find the kth smallest element in the matrix.Note that it is the kth smallest element in the sorted order, not the...
摘要:中序遍历复杂度时间空间思路因为左节点小于根节点小于右节点,二叉搜索树的一个特性就是中序遍历的结果就是树内节点从小到大顺序输出的结果。这里采用迭代形式,我们就可以在找到第小节点时马上退出。这样我们就可以用二叉树搜索的方法来解决这个问题了。 Kth Smallest Element in a BST Given a binary search tree, write a function...
摘要:解题思路本题需要找的是第小的节点值,而二叉搜索树的中序遍历正好是数值从小到大排序的,那么这题就和中序遍历一个情况。 Kth Smallest Element in a BSTGiven a binary search tree, write a function kthSmallest to find the kth smallest element in it. Note: You ...
阅读 903·2023-04-26 01:34
阅读 3340·2023-04-25 20:58
阅读 3193·2021-11-08 13:22
阅读 2092·2019-08-30 14:17
阅读 2497·2019-08-29 15:27
阅读 2649·2019-08-29 12:45
阅读 2960·2019-08-29 12:26
阅读 2790·2019-08-28 17:51